diff options
author | Jim Meyering <jim@meyering.net> | 2006-10-03 13:13:09 +0000 |
---|---|---|
committer | Jim Meyering <jim@meyering.net> | 2006-10-03 13:13:09 +0000 |
commit | da9541f18e6985593b73c30d121605e8cff62a7b (patch) | |
tree | fa536023ddb705bdc539244b7dd8bf1c74c0f95b /tests | |
parent | d2e7358a9be5b7f1b816e46f3a2cf151463f2208 (diff) | |
download | coreutils-da9541f18e6985593b73c30d121605e8cff62a7b.tar.xz |
With --force (-f), rm no longer fails for ENOTDIR.
* src/remove.c (ignorable_missing): New function.
Use it everywhere, rather than open-coding the test.
Andreas Schwab reported the ENOTDIR problem.
(ignorable_missing): Similarly, don't fail for ENAMETOOLONG.
* NEWS: Mention the bug fix.
* tests/rm/ignorable: New file. Test for the ENOTDIR case.
* tests/rm/ignore-name-too-long: New file. Test for ENAMETOOLONG.
* tests/rm/Makefile.am (TESTS): Add the new file names.
Diffstat (limited to 'tests')
-rw-r--r-- | tests/rm/Makefile.am | 2 | ||||
-rwxr-xr-x | tests/rm/ignorable | 49 | ||||
-rwxr-xr-x | tests/rm/ignore-name-too-long | 48 |
3 files changed, 99 insertions, 0 deletions
diff --git a/tests/rm/Makefile.am b/tests/rm/Makefile.am index 8fc7bcab8..2a1339e72 100644 --- a/tests/rm/Makefile.am +++ b/tests/rm/Makefile.am @@ -21,6 +21,8 @@ AUTOMAKE_OPTIONS = 1.1 gnits TESTS = \ + ignore-name-too-long \ + ignorable \ readdir-bug \ empty-inacc \ dir-nonrecur \ diff --git a/tests/rm/ignorable b/tests/rm/ignorable new file mode 100755 index 000000000..7c2b2ba9a --- /dev/null +++ b/tests/rm/ignorable @@ -0,0 +1,49 @@ +#!/bin/sh +# Ensure that rm -f existing-non-dir/anything exits successfully + +# Copyright (C) 2006 Free Software Foundation, Inc. + +# This program is free software; you can redistribute it and/or modify +# it under the terms of the GNU General Public License as published by +# the Free Software Foundation; either version 2 of the License, or +# (at your option) any later version. + +# This program is distributed in the hope that it will be useful, +# but WITHOUT ANY WARRANTY; without even the implied warranty of +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the +# GNU General Public License for more details. + +# You should have received a copy of the GNU General Public License +# along with this program; if not, write to the Free Software +# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA +# 02110-1301, USA. + +if test "$VERBOSE" = yes; then + set -x + rm --version +fi + +PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check + +pwd=`pwd` +t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$ +trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0 +trap '(exit $?); exit $?' 1 2 13 15 + +framework_failure=0 +mkdir -p $tmp || framework_failure=1 +cd $tmp || framework_failure=1 +touch existing-non-dir || framework_failure=1 + +if test $framework_failure = 1; then + echo "$0: failure in testing framework" 1>&2 + (exit 1); exit 1 +fi + +fail=0 + +# With coreutils-6.3, this would exit nonzero. It should not. +# Example from Andreas Schwab. +rm -f existing-non-dir/f > out 2>&1 || fail=1 + +(exit $fail); exit $fail diff --git a/tests/rm/ignore-name-too-long b/tests/rm/ignore-name-too-long new file mode 100755 index 000000000..78d4e557e --- /dev/null +++ b/tests/rm/ignore-name-too-long @@ -0,0 +1,48 @@ +#!/bin/sh +# Ensure that rm -f name_longer_than_FILENAME_MAX exits successfully + +# Copyright (C) 2006 Free Software Foundation, Inc. + +# This program is free software; you can redistribute it and/or modify +# it under the terms of the GNU General Public License as published by +# the Free Software Foundation; either version 2 of the License, or +# (at your option) any later version. + +# This program is distributed in the hope that it will be useful, +# but WITHOUT ANY WARRANTY; without even the implied warranty of +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the +# GNU General Public License for more details. + +# You should have received a copy of the GNU General Public License +# along with this program; if not, write to the Free Software +# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA +# 02110-1301, USA. + +if test "$VERBOSE" = yes; then + set -x + rm --version +fi + +PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check + +pwd=`pwd` +t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$ +trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0 +trap '(exit $?); exit $?' 1 2 13 15 + +framework_failure=0 +mkdir -p $tmp || framework_failure=1 +cd $tmp || framework_failure=1 + +if test $framework_failure = 1; then + echo "$0: failure in testing framework" 1>&2 + (exit 1); exit 1 +fi + +fail=0 + +# With coreutils-6.3, this would exit nonzero. It should not. +long_name=$(printf %0513d 0) +rm -f $long_name > out 2>&1 || fail=1 + +(exit $fail); exit $fail |